| Flutter Impeller |

Public Member Functions | List of all members
impeller::CircleGeometry Class Referencefinal

`#include <circle_geometry.h>`

Inheritance diagram for impeller::CircleGeometry:

## Public Member Functions
| CircleGeometry (const Point &center, Scalar radius)
| CircleGeometry (const Point &center, Scalar radius, Scalar stroke_width)
| ~CircleGeometry () override
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
Scalar | ComputeAlphaCoverage (const Matrix &transform) const override
Scalar | GetRadius () const
Scalar | GetStrokeWidth () const
Point | GetCenter () const
std::optional< Rect > | GetCoverage (const Matrix &transform) const override
GeometryResult | GetPositionBuffer (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
Public Member Functions inherited from impeller::Geometry
virtual | ~Geometry ()
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const flutter::DlPath &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const flutter::DlPath &path, const StrokeParameters &stroke={})
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeFilledArc (const Rect &oval_bounds, Degrees start, Degrees sweep, bool include_center)
static std::unique_ptr< Geometry > | MakeStrokedArc (const Rect &oval_bounds, Degrees start, Degrees sweep, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakeRoundSuperellipse (const Rect &rect, Scalar corner_radius)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

Definition at line 14 of file circle_geometry.h.

## Constructor & Destructor Documentation

## ◆ CircleGeometry() [1/2]

impeller::CircleGeometry::CircleGeometry | ( | const Point & | center,
|  | Scalar | radius
| ) |  |
| explicit

Definition at line 15 of file circle_geometry.cc.

16 : center_(center), radius_(radius), stroke_width_(-1.0f) {
17 FML_DCHECK(radius >= 0);
18 }

## ◆ CircleGeometry() [2/2]

impeller::CircleGeometry::CircleGeometry | ( | const Point & | center,
|  | Scalar | radius,
|  | Scalar | stroke_width
| ) |  |
| explicit

Definition at line 22 of file circle_geometry.cc.

25 : center_(center),
26 radius_(radius),
27 stroke_width_(std::max(stroke_width, 0.0f)) {
28 FML_DCHECK(radius >= 0);
29 FML_DCHECK(stroke_width >= 0);
30 }

## ◆ ~CircleGeometry()

impeller::CircleGeometry::~CircleGeometry | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ ComputeAlphaCoverage()

Scalar impeller::CircleGeometry::ComputeAlphaCoverage | ( | const Matrix & | transform | ) | const
| overridevirtual

Reimplemented from impeller::Geometry.

Definition at line 33 of file circle_geometry.cc.

33 {
34 if (stroke_width_ < 0) {
35 return 1;
36 }
37 return Geometry::ComputeStrokeAlphaCoverage(transform, stroke_width_);
38 }
impeller::Geometry::ComputeStrokeAlphaCoverage
static Scalar ComputeStrokeAlphaCoverage(const Matrix &entity, Scalar stroke_width)
Compute an alpha value to simulate lower coverage of fractional pixel strokes.
Definition: geometry.cc:149
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:312

References impeller::Geometry::ComputeStrokeAlphaCoverage(), and transform.

## ◆ CoversArea()

bool impeller::CircleGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| overridevirtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 78 of file circle_geometry.cc.

79 {
80 return false;
81 }

## ◆ GetCenter()

Point impeller::CircleGeometry::GetCenter | ( |  | ) | const

Definition at line 40 of file circle_geometry.cc.

40 {
41 return center_;
42 }

## ◆ GetCoverage()

std::optional< Rect > impeller::CircleGeometry::GetCoverage | ( | const Matrix & | transform | ) | const
| overridevirtual

Implements impeller::Geometry.

Definition at line 69 of file circle_geometry.cc.

69 {
70 Scalar half_width = stroke_width_ < 0 ? 0.0 : stroke_width_ * 0.5f;
71 Scalar outer_radius = radius_ + half_width;
72 return Rect::MakeLTRB(-outer_radius, -outer_radius, //
73 +outer_radius, +outer_radius)
74 .Shift(center_)
75 .TransformAndClipBounds(transform);
76 }
impeller::Scalar
float Scalar
Definition: scalar.h:19
impeller::TRect::Shift
constexpr TRect< T > Shift(T dx, T dy) const
Returns a new rectangle translated by the given offset.
Definition: rect.h:602
impeller::TRect< Scalar >::MakeLTRB
constexpr static TRect MakeLTRB(Type left, Type top, Type right, Type bottom)
Definition: rect.h:129

References impeller::TRect< Scalar >::MakeLTRB(), impeller::TRect< T >::Shift(), and transform.

## ◆ GetPositionBuffer()

GeometryResult impeller::CircleGeometry::GetPositionBuffer | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| overridevirtual

Implements impeller::Geometry.

Definition at line 52 of file circle_geometry.cc.

54 {
55 auto& transform = entity.GetTransform();
56
57 Scalar half_width = stroke_width_ < 0 ? 0.0
58 : LineGeometry::ComputePixelHalfWidth(
59 transform, stroke_width_);
60
61 // We call the StrokedCircle method which will simplify to a
62 // FilledCircleGenerator if the inner_radius is <= 0.
63 auto generator = renderer.GetTessellator().StrokedCircle(transform, center_,
64 radius_, half_width);
65
66 return ComputePositionGeometry(renderer, generator, entity, pass);
67 }
impeller::Geometry::ComputePositionGeometry
static GeometryResult ComputePositionGeometry(const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)
Definition: geometry.cc:26
impeller::LineGeometry::ComputePixelHalfWidth
static Scalar ComputePixelHalfWidth(const Matrix &transform, Scalar width)
Definition: line_geometry.cc:18

References impeller::LineGeometry::ComputePixelHalfWidth(), impeller::Geometry::ComputePositionGeometry(), impeller::ContentContext::GetTessellator(), impeller::Entity::GetTransform(), impeller::Tessellator::StrokedCircle(), and transform.

## ◆ GetRadius()

Scalar impeller::CircleGeometry::GetRadius | ( |  | ) | const

Definition at line 44 of file circle_geometry.cc.

44 {
45 return radius_;
46 }

## ◆ GetStrokeWidth()

Scalar impeller::CircleGeometry::GetStrokeWidth | ( |  | ) | const

Definition at line 48 of file circle_geometry.cc.

48 {
49 return stroke_width_;
50 }

## ◆ IsAxisAlignedRect()

bool impeller::CircleGeometry::IsAxisAlignedRect | ( |  | ) | const
| overridevirtual

Reimplemented from impeller::Geometry.

Definition at line 83 of file circle_geometry.cc.

83 {
84 return false;
85 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/circle_geometry.h
- impeller/entity/geometry/circle_geometry.cc